KyzderpsDerps = KyzderpsDerps or {}

-- Yoinked from esoui debugUtils
local function EmitMessage(text)
    if text == "" then
        text = "[Empty String]"
    end

    -- KDDSpamBuffer:AddMessage(text, 0.7, 0.7, 0.7)
end

local function EmitTable(t, indent, tableHistory)
    indent          = indent or "."
    tableHistory    = tableHistory or {}

    for k, v in pairs(t)
    do
        local vType = type(v)

        EmitMessage(indent.."("..vType.."): "..tostring(k).." = "..tostring(v))

        if(vType == "table")
        then
            if(tableHistory[v])
            then
                EmitMessage(indent.."Avoiding cycle on table...")
            else
                tableHistory[v] = true
                EmitTable(v, indent.."  ", tableHistory)
            end
        end
    end
end

function KyzderpsDerps.PrintSpam(...)
    for i = 1, select("#", ...) do
        local value = select(i, ...)
        if(type(value) == "table")
        then
            EmitTable(value)
        else
            EmitMessage(tostring (value))
        end
    end
end